///////////////////////////////////////////////////////////////////////
//                                                   41 Post                                       //
// Unity3D: JavaScript vs. C# - Part 1                                                //
// Created by DimasTheDriver in 23/Dez/2010                                     //
// Part of 'Unity3D: JavaScript vs. C# ' post series.                           //
// Availiable at:       http://www.41post.com/?p=1320                            //
/////////////////////////////////////////////////////////////////////

using UnityEngine;
using System.Collections;

public class Item : MonoBehaviour 
{
	//some protected variables
	protected int weight=0;
	protected int quantity=0;
	protected new string title;

	//a method that can be overridden
	protected virtual void Action()
	{
		//change the title to this is an item
		title="This is an Item.";
	}
	
	//called once per frame
	void Update()
	{
		//changes the title of the item
		Action();
	}
	
	//render GUI elements
	void OnGUI()
	{
		//Render instructions
		GUI.Label(new Rect(10,10,600,200),"Select one of the scripts attached to the 'Cube' GameObject. Only one script can be enabled at a given time.\n\nC# is enabled.");
		
		//Render the title
		GUI.Label(new Rect(10,70,500,200),title);
		
		//Render the weight
		GUI.Label(new Rect(10,100,500,200),"Weight: " + weight.ToString());
		
		//Render the quantity
		GUI.Label(new Rect(10,130,500,200),"Quantity: " + quantity.ToString());
	}
}
