///////////////////////////////////////////////////////////////////////
//                                                   41 Post                                       //
// Unity3D: JavaScript vs. C# - Part 4                                                //
// Created by DimasTheDriver in 23/Dez/2010                                     //
// Part of 'Unity3D: JavaScript vs. C# ' post series.                           //
// Availiable at:       http://www.41post.com/?p=1855                            //
/////////////////////////////////////////////////////////////////////

using UnityEngine;
using System.Collections;

public class Yield : MonoBehaviour
{
	//The text that will be outputted
	private string textS;
	//The counter that will be incremented
	private float counter = 0;
	//the 'CapsuleMover' script
	private CapsuleMover cmSC;
	
	void Awake()
	{
		//get the capsule mover
		cmSC = this.GetComponent<CapsuleMover>();
	}

	void Update ()
	{
		//doesn't generate an error but doesn't work either.
		//WaitThreeSeconds();//<=does nothing
		
		//start the coroutine named WaitThreeSeconds
		StartCoroutine("WaitThreeSeconds");//<=right
	}

	//Waits three seconds before executing
	IEnumerator WaitThreeSeconds()
	{
		//Wait three seconds
		yield return new WaitForSeconds(3);
		//converts the counter to a String and stores its value in textS
		textS = "Three seconds has passed, now I'm counting..."+counter.ToString();
		//add one to the counter
		++counter;
		//enables the CapsuleMover script
		cmSC.enabled = true;
	}

	/*This function is responsible for outputting text to the
	screen and rendering other GUI elements*/
	void OnGUI()
	{
		//The next line displays the first line of text
		GUI.Label(new Rect(20,20,100,100), "I'm a C# script and I will start counting in 3 seconds.");
		
		//Displays the counter
		GUI.Label(new Rect(20,140,100,100),textS);
		
		//Instructions
		GUI.Label(new Rect(20,420,460,20),"The scripts are inside the 'CapsuleJavaScript' and 'CapsuleC#' GameObjects.");
	}

}
