///////////////////////////////////////////////////////////////////////
//                                                   41 Post                                       //
// Unity3D: JavaScript vs. C# - Part 4                                                //
// Created by DimasTheDriver in 23/Dez/2010                                     //
// Part of 'Unity3D: JavaScript vs. C# ' post series.                           //
// Availiable at:       http://www.41post.com/?p=1855                            //
/////////////////////////////////////////////////////////////////////

//The text that will be outputted
private var textS:String;
//The counter that will be incremented
private var counter:float = 0;
//the 'CapsuleMover' script
private var cmSC : CapsuleMover;

function Awake()
{
	//get the capsule mover
	cmSC = this.GetComponent(CapsuleMover);
}

function Update ()
{
	//call the function that waits three seconds to execute
	WaitThreeSeconds();
}

//This function waits three seconds before executing
function WaitThreeSeconds()
{
	//Wait three seconds
	yield WaitForSeconds(3);
	//converts the counter to a String and stores its value in textS
	textS = "Three seconds has passed, now I'm counting..."+counter.ToString();
	//add one to the counter
	++counter;
	//enables the CapsuleMover script
	cmSC.enabled = true;
}

/*This function is responsible for outputting text to the
   screen and rendering other GUI elements*/
function OnGUI()
{
	//The next line displays the first line of text
	GUI.Label(new Rect(480,20,100,100), "I'm a JavaScript script and I will start counting in 3 seconds.");
	
	//Displays the counter
	GUI.Label(new Rect(480,140,100,100),textS);
	
	//Instructions
	GUI.Label(new Rect(20,420,460,20),"The scripts are inside the 'CapsuleJavaScript' and 'CapsuleC#' GameObjects.");
}
