///////////////////////////////////////////////////////////////////////
//                                                   41 Post                                       //
// Unity3D: JavaScript vs. C# - Part 5                                                //
// Created by DimasTheDriver in 23/Dez/2010                                     //
// Part of 'Unity3D: JavaScript vs. C# ' post series.                           //
// Availiable at:       http://www.41post.com/?p=1974                            //
/////////////////////////////////////////////////////////////////////

//Creates a ray object
private var ray : Ray;

//creates a RaycastHit, to query informarion about the objects that are colliding with the ray
private var hit : RaycastHit = new RaycastHit();

//Get this GameObject's Transform
private var capsTrans:Transform;

//a string to store the name of the object the ray collided with
private var wallName:String;

function Awake()
{
	//get this Transform
	capsTrans = this.GetComponent(Transform);
}

// Update is called once per frame
function Update () 
{
	//recreate the ray every frame
	ray = new Ray(capsTrans.position, Vector3.left);
	
	//Draw the ray (only works in Unity3D editor at the 'Scene' tab)
	Debug.DrawRay (ray.origin, ray.direction* 10, Color.magenta);
	
	//Casts a ray to see if something have hit it 
	if(Physics.Raycast(ray.origin,ray.direction, hit, 10))//cast the ray 10 units in distance
	{
		//Collision has happened, change wallName to the name of the GameObject that collided with it
		wallName = hit.collider.name;
	}
	else
	{
		//the ray isn't colliding with anything
		wallName = "none";
	}
}

//render GUI elements
function OnGUI()
{
	//instructions
	GUI.Label(new Rect(10,10,600,200),"The code is attached to the 'Capsule' game Object. Activate either the JavaScript or C# components. Only one must be enabled at a given time.\n\nJavaScript is enabled.");
	
	//the name of the object the ray is hitting
	GUI.Label(new Rect(10,80,300,20),"Name of the object being hit: "+wallName);
	
	//the distance the ray travelled before hitting the object
	GUI.Label(new Rect(10,100,300,20),"Distance: "+hit.distance);
}
